zash-sdk
================

<!-- WARNING: THIS FILE WAS AUTOGENERATED! DO NOT EDIT! -->

Delightful, ergonomic blockchain data SDK built for data scientist, ML
engineers and data analysts. Wrangle and explore transactions under a
minute.

## Install

``` sh
pip install zash-sdk
```

## Quickstart

### Authentication

Get your credentials from [zash.sh](https://zash.sh)

``` python
zash = Zash('your_username', 'your_api_key')
```

    Authenticated!

### Accessing NFT collection trades

Grab all Bored Ape trades in x2y2 since yesterday (contract address
[here](https://etherscan.io/address/0xbc4ca0eda7647a8ab7c2061c2e118a18a936f13d)):

``` python
bayc = zash.nft('eth').collection('0xBC4CA0EdA7647A8aB7C2061c2E118A18a936f13D')
```

``` python
trades_df = bayc.trades('yesterday')
trades_df.query("marketplace_name == 'x2y2'").head()
```

<div>
<style scoped>
    .dataframe tbody tr th:only-of-type {
        vertical-align: middle;
    }

    .dataframe tbody tr th {
        vertical-align: top;
    }

    .dataframe thead th {
        text-align: right;
    }
</style>
<table border="1" class="dataframe">
  <thead>
    <tr style="text-align: right;">
      <th></th>
      <th>id</th>
      <th>hash</th>
      <th>buyer</th>
      <th>seller</th>
      <th>collection_address</th>
      <th>token_id</th>
      <th>marketplace_address</th>
      <th>marketplace_name</th>
      <th>price</th>
      <th>currency</th>
      <th>block_hash</th>
      <th>block_number</th>
      <th>mint</th>
      <th>bundle</th>
      <th>timestamp</th>
      <th>updated_at</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <th>2</th>
      <td>af310da4-6263-3e84-8871-a5cc9cc12ce5</td>
      <td>0x4e08c077e733022dbf3d68a8e317d4c28da6baa9252d...</td>
      <td>0x7bF481e3a1Dd55618AC58F874481A9eAa3231734</td>
      <td>0x1d62df39f4D20119EcEEf66bFEE23c0afe49CeB8</td>
      <td>0xBC4CA0EdA7647A8aB7C2061c2E118A18a936f13D</td>
      <td>8914</td>
      <td>0x74312363e45DCaBA76c59ec49a7Aa8A65a67EeD3</td>
      <td>x2y2</td>
      <td>73.00</td>
      <td>ETH</td>
      <td>0x6bf5d53ce7ab3947354ec1b027b0ce69c6a3fd758364...</td>
      <td>15475224</td>
      <td>False</td>
      <td>False</td>
      <td>1662344352</td>
      <td>2022-09-05 02:31:19</td>
    </tr>
    <tr>
      <th>4</th>
      <td>0462d0ad-d0a5-3478-afdb-ceeb58b68a6b</td>
      <td>0x373c340cfc8f90096aad69b33b98d6be347c4ebe3d22...</td>
      <td>0x7bF481e3a1Dd55618AC58F874481A9eAa3231734</td>
      <td>0x1d62df39f4D20119EcEEf66bFEE23c0afe49CeB8</td>
      <td>0xBC4CA0EdA7647A8aB7C2061c2E118A18a936f13D</td>
      <td>6077</td>
      <td>0x74312363e45DCaBA76c59ec49a7Aa8A65a67EeD3</td>
      <td>x2y2</td>
      <td>73.00</td>
      <td>ETH</td>
      <td>0xf8a557791db98d8888c0b94e421baf6937511d3dde58...</td>
      <td>15475274</td>
      <td>False</td>
      <td>False</td>
      <td>1662345081</td>
      <td>2022-09-05 02:46:35</td>
    </tr>
    <tr>
      <th>56</th>
      <td>c8c81cee-a23b-340f-bb4d-81298c1fbef3</td>
      <td>0x04d1b88921fa61e760cb55fe30e36efc346c9c313399...</td>
      <td>0x7bF481e3a1Dd55618AC58F874481A9eAa3231734</td>
      <td>0xed2ab4948bA6A909a7751DEc4F34f303eB8c7236</td>
      <td>0xBC4CA0EdA7647A8aB7C2061c2E118A18a936f13D</td>
      <td>7404</td>
      <td>0x74312363e45DCaBA76c59ec49a7Aa8A65a67EeD3</td>
      <td>x2y2</td>
      <td>72.00</td>
      <td>WETH</td>
      <td>0xf767a152a503621334ec7f07d0d784cf5d3f7ed2da23...</td>
      <td>15479591</td>
      <td>False</td>
      <td>False</td>
      <td>1662405470</td>
      <td>2022-09-05 19:31:20</td>
    </tr>
    <tr>
      <th>67</th>
      <td>a92becf0-de72-3b15-b34f-76ef1261d3e8</td>
      <td>0xf0b4bb46af36b3ee16110b1b50bf42ac481f82dc8109...</td>
      <td>0xed2ab4948bA6A909a7751DEc4F34f303eB8c7236</td>
      <td>0xaf0f4479aF9Df756b9b2c69B463214B9a3346443</td>
      <td>0xBC4CA0EdA7647A8aB7C2061c2E118A18a936f13D</td>
      <td>9425</td>
      <td>0x74312363e45DCaBA76c59ec49a7Aa8A65a67EeD3</td>
      <td>x2y2</td>
      <td>69.95</td>
      <td>ETH</td>
      <td>0x9ec1d48c818c5f8ad282cf33a4fc7a6b9fe7eaea5bb5...</td>
      <td>15479585</td>
      <td>False</td>
      <td>False</td>
      <td>1662405361</td>
      <td>2022-09-05 19:31:20</td>
    </tr>
  </tbody>
</table>
</div>

A closer look at a trade:

``` python
trade = trades_df.query("marketplace_name == 'x2y2'").head(1).squeeze()
trade
```

    id                                  af310da4-6263-3e84-8871-a5cc9cc12ce5
    hash                   0x4e08c077e733022dbf3d68a8e317d4c28da6baa9252d...
    buyer                         0x7bF481e3a1Dd55618AC58F874481A9eAa3231734
    seller                        0x1d62df39f4D20119EcEEf66bFEE23c0afe49CeB8
    collection_address            0xBC4CA0EdA7647A8aB7C2061c2E118A18a936f13D
    token_id                                                            8914
    marketplace_address           0x74312363e45DCaBA76c59ec49a7Aa8A65a67EeD3
    marketplace_name                                                    x2y2
    price                                                               73.0
    currency                                                             ETH
    block_hash             0x6bf5d53ce7ab3947354ec1b027b0ce69c6a3fd758364...
    block_number                                                    15475224
    mint                                                               False
    bundle                                                             False
    timestamp                                                     1662344352
    updated_at                                           2022-09-05 02:31:19
    Name: 2, dtype: object

``` python
# you can check out the transaction on etherscan:
print(f"https://etherscan.io/tx/{trade['hash']}")
```

    https://etherscan.io/tx/0x4e08c077e733022dbf3d68a8e317d4c28da6baa9252d4f0a18498538b2c9c3f1

### Compare marketplaces:

``` python
all_trades_df = zash.nft('eth').trades('1 hour ago')
```

``` python
# offmarket marketplaces are labelled as -
all_trades_df\
    .query('marketplace_name != "-"')\
    .groupby('marketplace_name')\
    .agg({"price":'sum'})\
    .sort_values('price', ascending=False)\
    .plot(kind='bar', ylabel='price_in_eth', legend=False)
```

    <AxesSubplot:xlabel='marketplace_name', ylabel='price_in_eth'>

![](index_files/figure-gfm/cell-8-output-2.png)

### Network analysis on trades

We are building and enriching network analysis tools to be go deeper on
a given trade network. Most frequent use-case is detecting wash trades
or cyclical trades.

``` python
from zash_sdk.graph import *
network = build_network(bayc.trades('yesterday'))
plot_trade_network(network)
```

![](index_files/figure-gfm/cell-9-output-1.png)

### Stay tuned!

This is the beginning of what you can do with Zash SDK. We would be
adding transparent NFT price prediction and wallet based analysis tools
in the upcoming weeks. If you have any feature requests [get in
touch](mailto:efe@joinzash.com). We are also
[hiring](https://northern-steel-324.notion.site/Zash-is-Hiring-d5e19210b944486c8fd11f385a176999)!
